//rutiny pro podporu zobrazeni map na mapy.cz
//
//   1.0 Gord (4.4.2016)
//       MapyCzUcPar('lon1,lat1, lon2,lat2, ..., lonN,lanN'):string;
//         vypocet parametru 'uc' do URL pro zobrazeni vlastnich bodu


//prevod jednoho cisla souradnic na hash
function MapyczSerializeNumber(a,b:integer):string;
var c:string;
    d:integer;
    _alphabet:string;
begin
  //string, kterym se prevadi na hash
  //originalni javascript pocita index znaku od 0, pascal od 1, proto zvysujeme o 1
  _alphabet:='0ABCD2EFGH4IJKLMN6OPQRST8UVWXYZ-1abcd3efgh5ijklmn7opqrst9uvwxyz.';
  c:='';
  //ShowMessage('1. a='+IntToStr(a)+', b='+IntToStr(b));
  if(-1024<=a) and (1024>a) then begin
    c:=c+_alphabet[1+((a+1024) SHR 6)];
    c:=c+_alphabet[1+((a+1024) AND 63)];
  end
  else begin
    if(-32768<=a) and (32768>a) then begin
      d:=131072 OR (a+32768);
      //ShowMessage('1111111 d='+IntToStr(d)+', a='+IntToStr(a));
    end
    else begin
      d:=805306368 OR b AND 268435455;
      //ShowMessage('2222222 d='+IntToStr(d)+', b='++IntToStr(b));
      //ShowMessage('2. idx[1]='+IntToStr(d SHR 24 AND 63)+', idx[2]='+IntToStr(d SHR 18 AND 63));
      c:=c+_alphabet[1+(d SHR 24 AND 63)];
      c:=c+_alphabet[1+(d SHR 18 AND 63)];
    end;
    //ShowMessage('3. idx[3]='+IntToStr(d SHR 12 AND 63)+', idx[4]='+IntToStr(d SHR 6 AND 63)+', idx[5]='+IntToStr(d AND 63));
    c:=c+_alphabet[1+(d SHR 12 AND 63)];
    c:=c+_alphabet[1+(d SHR 6 AND 63)];
    c:=c+_alphabet[1+(d AND 63)];
  end;
  Result:=c;
end;

//vypocet parametru uc=... (zakodovane souradnice vsech bodu
function MapyczUcPar(sCoords:string):string;
var s:string;
    fLon,fLat:extended;
    b,c,g,f:integer;
begin
  b:=0; c:=0; s:='';   //inicializace
  while(sCoords<>'') do begin  //zpracujeme vsechny souradnice
    fLon:=StrToFloat(Fetch(sCoords,','));      //ziskame lon
    fLat:=StrToFloat(Fetch(sCoords,','));      //ziskame lat
    g:=Round(268435456*(fLon+180)/360);
    f:=Round(268435456*(fLat+90)/180);
    c:=f-c;
    s:=s+MapyczSerializeNumber(g-b,g);
    s:=s+MapyczSerializeNumber(c,f);
    b:=g;
    c:=f;
  end;
  Result:=s;
end;

